<script setup>
// ----------------------------------------------------------------
// Import
// ----------------------------------------------------------------

import { useNodeStore } from "@/stores/useNodeStore";
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";
import { ref } from "vue";

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

const nodeStore = useNodeStore();
const workspaceStore = useWorkspaceStore();

const workspaceFound = ref(null);
const search = ref("");

const route = useRoute();
workspaceStore.currentWSlug = route.params.wslug;

const newSubmissionDialog = ref(false);

// ----------------------------------------------------------------
// Lifecycle
// ----------------------------------------------------------------

onMounted(async () => {
  await workspaceStore.fetchWorkspaces();

  if (workspaceStore.workspaceMap.has(route.params.wslug)) {
    workspaceFound.value = true;
    if (workspaceStore.workspaceRoles.size === 0) {
      await workspaceStore.fetchWorkspaceRoles();
    }

    if (nodeStore.nodes.size === 0) {
      await nodeStore.fetchNodes();
    }
  } else {
    workspaceFound.value = false;
  }
});
</script>

<template>
  <v-container fluid class="pa-4">
    <h1 class="ma-2">
      <v-icon class="me-2">
        mdi-database-arrow-up-outline
      </v-icon>Submissions
    </h1>
    <v-row no-gutters>
      <v-col>
        <div class="d-flex justify-end my-3 sticky-div">
          <v-text-field
            v-model="search"
            label="Search"
            prepend-inner-icon="mdi-magnify"
            hide-details
            single-line
            density="compact"
            class="me-2"
            style="max-width: 260px"
          />
          <v-btn
            :active="false"
            height="40px"
            @click="newSubmissionDialog = true"
          >
            New submission
          </v-btn>
        </div>
        <div class="mt-10">
          <SubmissionTable :search="search" />
        </div>
      </v-col>
    </v-row>
  </v-container>

  <SubmissionNew
    :newSubmissionDialog="newSubmissionDialog"
    @newSubmissionDialog="newSubmissionDialog = false"
  />
</template>

<style></style>
